(* file: stripes.ml
   author: Bob Muller

   Code for CS1103 Computer Science I Honors

   This colors the 2D plane with randomly colored vertical
  stripes.
*)
open World
open Image
open Color
open Cs1103

let pi = acos(-1.)
let displayWidth = 800.0
let displayHeight = displayWidth

(* stripe : float -> Image.t
*)
let verticalStripe width =
  let color = Cs1103.randomColor ()
  in
  Image.rectangle width displayHeight color

(* stripes : unit -> Image.t
 *)
let stripes () =
  let n = 5 (* 1 + (Random.int 16) *) in
  let width = displayWidth /. (float n) in
  let empty = Image.empty_scene displayWidth displayHeight in
  let rec addStripes m image =
    match m = 0 with
    | true  -> image
    | false ->
      let stripe = verticalStripe width in
      let x = width *. (float (m - 1)) in
      let newImage = Image.place_image stripe (x, 0.) image
      in
      addStripes (m - 1) newImage
  in
  addStripes n empty

let () =
  World.big_bang ()
    ~name:"Stripes"
    ~width:(f2I displayWidth)
    ~height:(f2I displayHeight)
    ~to_draw:stripes
